(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "./CurvesPathGenerator"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.loadCurvesPath = exports.curvesPathName = void 0;
    const CurvesPathGenerator_1 = require("./CurvesPathGenerator");
    exports.curvesPathName = "curvesPathGenerator";
    async function loadCurvesPath(engine, refresh = true) {
        await engine.addPathGenerator(exports.curvesPathName, new CurvesPathGenerator_1.CurvesPathGenerator(), refresh);
    }
    exports.loadCurvesPath = loadCurvesPath;
});
